/*
 * Copyright (C) 2015 PHYTEC Messtechnik GmbH,
 * Author:   Alexander Fratzer <a.fratzer@phytec.de>
 *           Alexander Aring   <a.aring@phytec.de>
 * Released under the MIT license
 */

#ifndef __REGPARSE_H__
#define __REGPARSE_H__

#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#include <stdint.h>

#include <sys/types.h>

#include <linux/videodev2.h>

#define MAX_LINE_LENGTH 1024

/*-----------------------------------------------------------------------------
 *  Parse the register file and call do_something for each regline.
 *-----------------------------------------------------------------------------*/
int reg_file_parse(char *filepath,
		   int do_something(uint32_t address, uint64_t reg,
					uint64_t val, char mode,
					uint32_t use_subdev), uint32_t use_sd);

#endif				/* __REGPARSE_H__ */
